/** Game Debugger *************************************************************/
void gameDebug(){
	cnrom_chrbank(0);
	resetMasterUpdateList();
	oam_clear();
	clearOamTiles();
	pal_bg(palBG_TitleOld);
	pal_spr(palSPR_Sprite1);
	unrle_vram(nam_gameDebug,0x2000);

	*(byte*)GAMEDEBUG_ACTIVE=1; // set debug flag.
	if(s<5||s>16){ s=5; }

	/* how many items am i using
	 * 4 for the new size display
	 * 
	 */
	set_vram_update(2,masterUpdList);

	ppu_on_all();
	pal_fade_to(4,3);

	// todo: rand8();

	while(1){
		ppu_waitnmi();
		++frameCount;

		// tens
		masterUpdList[0]=0x20;
		masterUpdList[1]=0xCA;
		masterUpdList[2]=((s/10)%10)+0x30;
		// ones
		masterUpdList[3]=0x20;
		masterUpdList[4]=0xCB;
		masterUpdList[5]=(s%10)+0x30;

		pad=pad_trigger(0);
		if(pad&PAD_B){ // exit
			curScreen=1;
			*(byte*)GAMEDEBUG_ACTIVE=0; // unset debug flag.
			break;
		}
		if(pad&PAD_A){ // play
			cursorX=0; cursorY=0;
			puzzleW=s; puzzleH=s; // set new puzzle size
			z=s*s;
			curScreen=4;
			break;
		}
		if(pad&PAD_UP){ if(s<16){++s;} else{ s=5; } }
		if(pad&PAD_DOWN){ if(s>5){ --s; } else{ s=16; } }
	}

	// move to next screen
	pal_fade_to(0,3);
}

// gameplay section
if(*(byte*)GAMEDEBUG_ACTIVE){ // game debug mode
		// mode text
		vram_write((unsigned char *)pause_Debug,0x2509,6);

		// top line
		vram_write((unsigned char *)pause_DebugLevel1,0x2548,13);

		// bottom line
		vram_write((unsigned char *)pause_DebugLevel2,0x2568,10);
	}
	else{ // non-game debug
		//...
	}

// main loop:
case 0xD8: gameDebug(); break;	// temp; remove for final