#!/bin/sh

FP_VIDEO='NTSC'
FP_VARIANT='freem'
FP_VER='0.02'
FP_UNMANGLED_VERSION="$FP_VIDEO-$FP_VARIANT"

FULL_DATE="`date +'%Y/%m/%d %H:%M'`"
FP_DATE="`echo $FULL_DATE | cut -d ' ' -f 1`"
FP_TIME="`echo $FULL_DATE | cut -d ' ' -f 2`"

[ "x$CA65" = "x" ] && CA65=`which ca65`
[ "x$CC65" = "x" ] && CC65=`which cc65`
[ "x$LD65" = "x" ] && LD65=`which ld65`
[ "x$CC65_CFLAGS" = "x" ] && CC65_CFLAGS='-Oi'

cat >verInfo.h <<EOS
	const unsigned char verNum[]="${FP_VER}";
	const unsigned char verVariant[]="${FP_UNMANGLED_VERSION}";
	const unsigned char verDate[]="${FP_DATE}";
	const unsigned char verTime[]="${FP_TIME}";
EOS

$CC65 $CC65_CFLAGS picross.c --add-source
$CA65 $CC65_ASFLAGS crt0.s

# -- freemly things
$CA65 $CC65_ASFLAGS reset.s
$CA65 $CC65_ASFLAGS sram.s
# -- end freemly things

$CA65 $CC65_ASFLAGS picross.s
# ld65 -o picross.nes -C nes.cfg crt0.o ft/driver.o resetSig.o picross.o nes-runtime.lib
$LD65 $CC65_LDFLAGS -o picross.nes -C nes.cfg crt0.o reset.o sram.o picross.o nes-runtime.lib

rm picross.s
