; save format is detailed in readme.txt
.export _sramCheckHeader

_sramCheckHeader:
	; look for "FPSD" in first 4 bytes.
	lda $6000
	cmp #$46
	bne sramWriteDefault

	lda $6001
	cmp #$50
	bne sramWriteDefault

	lda $6002
	cmp #$53
	bne sramWriteDefault

	lda $6003
	cmp #$44
	bne sramWriteDefault

	lda #$00
	rts

; sramWriteDefault is called if the save data does not exist or is corrupted.
sramWriteDefault:
	; $6000 = 0x46
	lda #$46
	sta $6000

	; $6001 = 0x50
	lda #$50
	sta $6001

	; $6002 = 0x53
	lda #$53
	sta $6002

	; $6003 = 0x44
	lda #$44
	sta $6003

	; $6004 = 0x00 (game version)
	lda #0
	sta $6004

	; todo: checksum at $6005-$6006

	; $6007 - X Protection (On/0x01 by default)
	ldx #1
	stx $6007

	;  write 0x00 to all remaining bytes (see picross.c)
	lda #$01

	rts
