/* zp.h - zero page variables. */
#ifndef ZEROPAGE_H
#define ZEROPAGE_H

// later version of cc65 throws warning:
// #pragma bssseg/dataseg is obsolete, please use #pragma bss-name/data-name instead
#pragma bssseg (push,"ZEROPAGE")
#pragma dataseg(push,"ZEROPAGE")
//#pragma bss-name (push,"ZEROPAGE")
//#pragma data-name(push,"ZEROPAGE")
static byte g,h,i,j,k,m,n,p,q,r,s,t,u,v,w,x,y,z;
static byte wait,pad,curSprite;
static word i16,j16,k16,m16,randWord;

// global game stuffs
static byte xProtection,curScreen,frameCount,gameTick,bright;

// main menu crap
static byte explainCount,explainLine;

// normal menu crap
static byte pageNum;

/* gameplay stuff */

// shared between modes
static byte gameMode,gameStatus,repeatDir,enableLifeMeter,numLives;
static byte sec,min,blinky,pauseStatus,pauseCursor;

// for supplying different styles of the gameplay screen
/* stageStyle:
 *	0=Classic, 1=Checker, 2=Diamond, 3=Hearts, 4=Squares, 5=Stars
 * stagePal:
 *	uses linear mapping of palettes. See Palettes.h for actual order.
 */
static byte stageStyle, stagePal;

// puzzleW and puzzleH (and hence cursorX/Y) are max 16 for famipicro1.
static byte puzzleW,puzzleH,cursorX,cursorY;

static word gameLevel;			// still needs to be a word, since 999 > 256

// normal mode only
// todo: what even belongs here

// random mode only
//** random single **
static byte randLevelSize,randLevelDiff,useSeed;
static word levelSeed;

//** random set **
static word numRandSetLevels;	// see gameLevel above

// see above
#pragma dataseg(push,"CODE")
//#pragma data-name(push,"CODE")

#endif
